#ifndef CATMULL_H
#define CATMULL_H

#include <stdio.h>
#include <stdlib.h>

typedef struct 
{
  float x, y, z;		
}g3dVector;

//////// Liste de point de contrle de la trajectoire/////

typedef struct MyPathList
{
  float x, y, z; // position de l'objet dans la trajectoire pour un pt de contrle

  struct MyPathList *next; // lment suivant

}MyPathList;

/////// Une structure par trajectoire ///// 

typedef struct MyTrajectory
{
  struct MyPathList *firstPosition;	// permet d'avoir un pointeur vers le dbut de la liste
  float time;			// temps de 0  1 ncessaire pour catmull
  struct MyPathList *path;	// stock la liste des positions de l'objet et de sa cible

  int loop;			// determine si la trajectoire est boucle
  float startTime;	// temps  couler avant le dpart de l'animation
  float speed;		// vitesse de l'animation
  int NbPositions;

	float x, y, z;	// position actuelle de l'objet dans la trajectoire

}MyTrajectory;


void LoadObjectPath(char *File_name, MyTrajectory *traj);
void CatmullUpdate(float value, MyTrajectory *objPosition);
void CatmullGivePosition(MyTrajectory *objPosition);
void CatmullFree(MyTrajectory *ListToFree);


#endif	/* CATMULL_H */
